﻿using System;
using System.IO;

namespace MaszynaTuringa
{
    public static class TuringHelper
    {
        public static void ConsoleWriteLine(this Turing turing)
        {
            Console.WriteLine("Stan głowicy: " + turing.StanGłowicy);
            Console.WriteLine("Taśma: " + turing.Taśma);
            Console.WriteLine("Program: ");
            foreach (string linia in turing.Program) Console.WriteLine(linia);
        }
    }

    class Program
    {
        static void Main(string[] args)
        {
            string[] kodProgramu = File.ReadAllLines("program.txt");
            string taśma = File.ReadAllText("taśma.txt");

            Console.WriteLine("Początkowy stan maszyny: " + taśma);
            Console.WriteLine("Program: ");
            foreach (string linia in kodProgramu) Console.WriteLine(linia);

            Turing turing = new Turing(taśma, kodProgramu);
            //TuringHelper.ConsoleWriteLine(turing);
            turing.ConsoleWriteLine();
        }
    }
}
