﻿using System;
using System.Collections.Generic;
using System.Text;

namespace MaszynaTuringa
{
    using Czwórki = SortedList<(char stanGłowicy, char wartośćNaTaśmie), (char nowyStanGłowicy, char nowaWartośćNaTaśmie)>;

    public class Turing
    {
        public string Taśma { get; private set; }
        public (int, char) StanGłowicy { get; private set; }
        public string[] Program { get; private set; }

        private static ((int, char) stanGłowicy, string taśma) analizujTaśmęZeStanemGłowicy(string s)
        {
            int położenieGłowicy = -1;
            int liczbaMałychLiter = 0;
            int liczbaZnakówNiebędącychLiterami = 0;
            for(int i = 0; i < s.Length; ++i)
            {
                if (char.IsLower(s[i]))
                {
                    liczbaMałychLiter++;
                    położenieGłowicy = i;
                }
                if (!char.IsLetter(s[i])) liczbaZnakówNiebędącychLiterami++;
            }
            if (liczbaMałychLiter != 1) throw new Exception("Błędny zapis taśmy. Musi być jeden symboli głowicy");
            if (liczbaZnakówNiebędącychLiterami > 0) throw new Exception("Niedozwolone znaki w opisie taśmy");

            (int, char) stanGłowicy = (położenieGłowicy, s[położenieGłowicy]);
            string taśma = s.Remove(położenieGłowicy, 1);

            return (stanGłowicy, taśma);
        }

        private static Czwórki parsujProgram(string[] kodProgramu)
        {

        }

        public Turing(string taśmaZeStanemGłowicy, string[] program)
        {
            var stanMaszyny = analizujTaśmęZeStanemGłowicy(taśmaZeStanemGłowicy);
            this.StanGłowicy = stanMaszyny.stanGłowicy;
            this.Taśma = stanMaszyny.taśma;
            this.Program = program;
        }


    }
}
